import java.util.*;

interface Trade {}
record Buy(String ticker, int quantity) implements Trade {}
record Sell(String ticker, int quantity) implements Trade {}

public class Sample {
  public static boolean processBuy(Buy buy) {
    System.out.println("processing a buy for " + buy);
    return true;
  }

  public static boolean processSell(Sell sell) {
    System.out.println("processing a sell for " + sell);
    return true;
  }

  public static boolean process(Trade trade) {
    return switch(trade) {
      case Buy buy when buy.quantity() >= 5000 -> {
        System.out.println("call audit routine");
        yield processBuy(buy);
      }
      case Buy buy -> processBuy(buy);
      case Sell sell -> processSell(sell);
      default -> {
        System.out.println("No clue what this is");
        yield false;
      }
    };
  }

  public static void main(String[] args) {
    System.out.println(process(new Buy("GOOG", 5000)));
    System.out.println(process(new Buy("GOOG", 200)));
    System.out.println(process(new Sell("AMZN", 300)));
  }
}
